import { ActionSheetIOSOptions } from 'react-native';
export declare type ActionSheetOption = {
    destructive?: boolean;
    text: string;
    onPress: () => void | Promise<void>;
};
export declare type ActionSheetConfig = {
    title?: string;
    message?: string;
    options: ActionSheetOption[];
    cancel?: {
        text?: string;
        onPress?: () => void | Promise<void>;
    } | false;
    tintColor?: string;
    anchor?: number;
};
export declare const ActionSheet: {
    showActionSheetWithOptions(options: ActionSheetIOSOptions, callback: (buttonIndex: number) => void): void;
    options(options: ActionSheetOption[] | ActionSheetConfig, config?: Pick<ActionSheetConfig, "title" | "message" | "cancel" | "tintColor" | "anchor"> | undefined): Promise<void>;
};
